Skip to content
v2.274.0

Amazon API Gateway Construct Library ​

Amazon API Gateway is a fully managed service that makes it easy for developers to publish, maintain, monitor, and secure APIs at any scale. Create an API to access data, business logic, or functionality from your back-end services, such as applications running on Amazon Elastic Compute Cloud (Amazon EC2), code running on AWS Lambda, or any web application.

Defining APIs ​

APIs are defined as a hierarchy of resources and methods. addResource and addMethod can be used to build this hierarchy. The root resource is api.root.

For example, the following code defines an API that includes the following HTTP endpoints: ANY /, GET /books, POST /books, GET /books/{book_id}, DELETE /books/{book_id}.

ts
const api = new apigateway.RestApi(this, 'books-api');

api.root.addMethod('ANY');

const books = api.root.addResource('books');
books.addMethod('GET');
books.addMethod('POST');

const book = books.addResource('{book_id}');
book.addMethod('GET');
book.addMethod('DELETE');
python
api = apigateway.RestApi(self, "books-api")

api.root.add_method("ANY")

books = api.root.add_resource("books")
books.add_method("GET")
books.add_method("POST")

book = books.add_resource("{book_id}")
book.add_method("GET")
book.add_method("DELETE")
java
RestApi api = new RestApi(this, "books-api");

api.root.addMethod("ANY");

Resource books = api.root.addResource("books");
books.addMethod("GET");
books.addMethod("POST");

Resource book = books.addResource("{book_id}");
book.addMethod("GET");
book.addMethod("DELETE");
csharp
var api = new RestApi(this, "books-api");

api.Root.AddMethod("ANY");

var books = api.Root.AddResource("books");
books.AddMethod("GET");
books.AddMethod("POST");

var book = books.AddResource("{book_id}");
book.AddMethod("GET");
book.AddMethod("DELETE");
go
api := apigateway.NewRestApi(this, jsii.String("books-api"))

api.Root.AddMethod(jsii.String("ANY"))

books := api.Root.AddResource(jsii.String("books"))
books.AddMethod(jsii.String("GET"))
books.AddMethod(jsii.String("POST"))

book := books.AddResource(jsii.String("{book_id}"))
book.AddMethod(jsii.String("GET"))
book.AddMethod(jsii.String("DELETE"))

To give an IAM User or Role permission to invoke a method, use grantExecute:

ts
declare const api: apigateway.RestApi;
declare const user: iam.User;

const method = api.root.addResource('books').addMethod('GET');
method.grantExecute(user);
python
# api: apigateway.RestApi
# user: iam.User


method = api.root.add_resource("books").add_method("GET")
method.grant_execute(user)
java
RestApi api;
User user;


Method method = api.root.addResource("books").addMethod("GET");
method.grantExecute(user);
csharp
RestApi api;
User user;


var method = api.Root.AddResource("books").AddMethod("GET");
method.GrantExecute(user);
go
var api RestApi
var user User


method := api.Root.AddResource(jsii.String("books")).AddMethod(jsii.String("GET"))
method.GrantExecute(user)

Breaking up Methods and Resources across Stacks ​

It is fairly common for REST APIs with a large number of Resources and Methods to hit the CloudFormation limit of 500 resources per stack.

To help with this, Resources and Methods for the same REST API can be re-organized across multiple stacks. A common way to do this is to have a stack per Resource or groups of Resources, but this is not the only possible way. The following example uses sets up two Resources '/pets' and '/books' in separate stacks using nested stacks:

ts
import type { Construct } from 'constructs';
import type { NestedStackProps } from '../../core';
import { App, CfnOutput, NestedStack, Stack } from '../../core';
import type { Method } from '../lib';
import { Deployment, MockIntegration, PassthroughBehavior, RestApi, Stage } from '../lib';

/**
 * This file showcases how to split up a RestApi's Resources and Methods across nested stacks.
 *
 * The root stack 'RootStack' first defines a RestApi.
 * Two nested stacks BooksStack and PetsStack, create corresponding Resources '/books' and '/pets'.
 * They are then deployed to a 'prod' Stage via a third nested stack - DeployStack.
 *
 * To verify this worked, go to the APIGateway
 */

class RootStack extends Stack {
  constructor(scope: Construct) {
    super(scope, 'integ-restapi-import-RootStack');

    const restApi = new RestApi(this, 'RestApi', {
      cloudWatchRole: true,
      deploy: false,
    });
    restApi.root.addMethod('ANY');

    const petsStack = new PetsStack(this, {
      restApiId: restApi.restApiId,
      rootResourceId: restApi.restApiRootResourceId,
    });
    const booksStack = new BooksStack(this, {
      restApiId: restApi.restApiId,
      rootResourceId: restApi.restApiRootResourceId,
    });
    new DeployStack(this, {
      restApiId: restApi.restApiId,
      methods: petsStack.methods.concat(booksStack.methods),
    });

    new CfnOutput(this, 'PetsURL', {
      value: `https://${restApi.restApiId}.execute-api.${this.region}.amazonaws.com/prod/pets`,
    });

    new CfnOutput(this, 'BooksURL', {
      value: `https://${restApi.restApiId}.execute-api.${this.region}.amazonaws.com/prod/books`,
    });
  }
}

interface ResourceNestedStackProps extends NestedStackProps {
  readonly restApiId: string;

  readonly rootResourceId: string;
}

class PetsStack extends NestedStack {
  public readonly methods: Method[] = [];

  constructor(scope: Construct, props: ResourceNestedStackProps) {
    super(scope, 'integ-restapi-import-PetsStack', props);

    const api = RestApi.fromRestApiAttributes(this, 'RestApi', {
      restApiId: props.restApiId,
      rootResourceId: props.rootResourceId,
    });

    const method = api.root.addResource('pets').addMethod('GET', new MockIntegration({
      integrationResponses: [{
        statusCode: '200',
      }],
      passthroughBehavior: PassthroughBehavior.NEVER,
      requestTemplates: {
        'application/json': '{ "statusCode": 200 }',
      },
    }), {
      methodResponses: [{ statusCode: '200' }],
    });

    this.methods.push(method);
  }
}

class BooksStack extends NestedStack {
  public readonly methods: Method[] = [];

  constructor(scope: Construct, props: ResourceNestedStackProps) {
    super(scope, 'integ-restapi-import-BooksStack', props);

    const api = RestApi.fromRestApiAttributes(this, 'RestApi', {
      restApiId: props.restApiId,
      rootResourceId: props.rootResourceId,
    });

    const method = api.root.addResource('books').addMethod('GET', new MockIntegration({
      integrationResponses: [{
        statusCode: '200',
      }],
      passthroughBehavior: PassthroughBehavior.NEVER,
      requestTemplates: {
        'application/json': '{ "statusCode": 200 }',
      },
    }), {
      methodResponses: [{ statusCode: '200' }],
    });

    this.methods.push(method);
  }
}

interface DeployStackProps extends NestedStackProps {
  readonly restApiId: string;

  readonly methods?: Method[];
}

class DeployStack extends NestedStack {
  constructor(scope: Construct, props: DeployStackProps) {
    super(scope, 'integ-restapi-import-DeployStack', props);

    const deployment = new Deployment(this, 'Deployment', {
      api: RestApi.fromRestApiId(this, 'RestApi', props.restApiId),
    });
    if (props.methods) {
      for (const method of props.methods) {
        deployment.node.addDependency(method);
      }
    }
    new Stage(this, 'Stage', { deployment });
  }
}

new RootStack(new App());
python
from aws_cdk.aws_apigateway import IntegrationResponse, MethodResponse, IntegrationResponse, MethodResponse
from constructs import Construct
from aws_cdk import NestedStackProps
from aws_cdk import App, CfnOutput, NestedStack, Stack
from aws_cdk.aws_apigateway import Method
from aws_cdk.aws_apigateway import Deployment, MockIntegration, PassthroughBehavior, RestApi, Stage

#
# This file showcases how to split up a RestApi's Resources and Methods across nested stacks.
#
# The root stack 'RootStack' first defines a RestApi.
# Two nested stacks BooksStack and PetsStack, create corresponding Resources '/books' and '/pets'.
# They are then deployed to a 'prod' Stage via a third nested stack - DeployStack.
#
# To verify this worked, go to the APIGateway
#

class RootStack(Stack):
    def __init__(self, scope):
        super().__init__(scope, "integ-restapi-import-RootStack")

        rest_api = RestApi(self, "RestApi",
            cloud_watch_role=True,
            deploy=False
        )
        rest_api.root.add_method("ANY")

        pets_stack = PetsStack(self,
            rest_api_id=rest_api.rest_api_id,
            root_resource_id=rest_api.rest_api_root_resource_id
        )
        books_stack = BooksStack(self,
            rest_api_id=rest_api.rest_api_id,
            root_resource_id=rest_api.rest_api_root_resource_id
        )
        DeployStack(self,
            rest_api_id=rest_api.rest_api_id,
            methods=pets_stack.methods.concat(books_stack.methods)
        )

        CfnOutput(self, "PetsURL",
            value=f"https://{restApi.restApiId}.execute-api.{this.region}.amazonaws.com/prod/pets"
        )

        CfnOutput(self, "BooksURL",
            value=f"https://{restApi.restApiId}.execute-api.{this.region}.amazonaws.com/prod/books"
        )

class PetsStack(NestedStack):

    def __init__(self, scope, *, restApiId, rootResourceId, parameters=None, timeout=None, notificationArns=None, removalPolicy=None, description=None, suppressTemplateIndentation=None):
        super().__init__(scope, "integ-restapi-import-PetsStack", restApiId=restApiId, rootResourceId=rootResourceId, parameters=parameters, timeout=timeout, notificationArns=notificationArns, removalPolicy=removalPolicy, description=description, suppressTemplateIndentation=suppressTemplateIndentation)

        api = RestApi.from_rest_api_attributes(self, "RestApi",
            rest_api_id=rest_api_id,
            root_resource_id=root_resource_id
        )

        method = api.root.add_resource("pets").add_method("GET", MockIntegration(
            integration_responses=[IntegrationResponse(
                status_code="200"
            )],
            passthrough_behavior=PassthroughBehavior.NEVER,
            request_templates={
                "application/json": "{ \"statusCode\": 200 }"
            }
        ),
            method_responses=[MethodResponse(status_code="200")]
        )

        self.methods.push(method)

class BooksStack(NestedStack):

    def __init__(self, scope, *, restApiId, rootResourceId, parameters=None, timeout=None, notificationArns=None, removalPolicy=None, description=None, suppressTemplateIndentation=None):
        super().__init__(scope, "integ-restapi-import-BooksStack", restApiId=restApiId, rootResourceId=rootResourceId, parameters=parameters, timeout=timeout, notificationArns=notificationArns, removalPolicy=removalPolicy, description=description, suppressTemplateIndentation=suppressTemplateIndentation)

        api = RestApi.from_rest_api_attributes(self, "RestApi",
            rest_api_id=rest_api_id,
            root_resource_id=root_resource_id
        )

        method = api.root.add_resource("books").add_method("GET", MockIntegration(
            integration_responses=[IntegrationResponse(
                status_code="200"
            )],
            passthrough_behavior=PassthroughBehavior.NEVER,
            request_templates={
                "application/json": "{ \"statusCode\": 200 }"
            }
        ),
            method_responses=[MethodResponse(status_code="200")]
        )

        self.methods.push(method)

class DeployStack(NestedStack):
    def __init__(self, scope, *, restApiId, methods=None, parameters=None, timeout=None, notificationArns=None, removalPolicy=None, description=None, suppressTemplateIndentation=None):
        super().__init__(scope, "integ-restapi-import-DeployStack", restApiId=restApiId, methods=methods, parameters=parameters, timeout=timeout, notificationArns=notificationArns, removalPolicy=removalPolicy, description=description, suppressTemplateIndentation=suppressTemplateIndentation)

        deployment = Deployment(self, "Deployment",
            api=RestApi.from_rest_api_id(self, "RestApi", rest_api_id)
        )
        if methods:
            for method in methods:
                deployment.node.add_dependency(method)
        Stage(self, "Stage", deployment=deployment)

RootStack(App())
java
import software.constructs.Construct;
import software.amazon.awscdk.NestedStackProps;
import software.amazon.awscdk.App;
import software.amazon.awscdk.CfnOutput;
import software.amazon.awscdk.NestedStack;
import software.amazon.awscdk.Stack;
import software.amazon.awscdk.services.apigateway.Method;
import software.amazon.awscdk.services.apigateway.Deployment;
import software.amazon.awscdk.services.apigateway.MockIntegration;
import software.amazon.awscdk.services.apigateway.PassthroughBehavior;
import software.amazon.awscdk.services.apigateway.RestApi;
import software.amazon.awscdk.services.apigateway.Stage;

/**
 * This file showcases how to split up a RestApi's Resources and Methods across nested stacks.
 *
 * The root stack 'RootStack' first defines a RestApi.
 * Two nested stacks BooksStack and PetsStack, create corresponding Resources '/books' and '/pets'.
 * They are then deployed to a 'prod' Stage via a third nested stack - DeployStack.
 *
 * To verify this worked, go to the APIGateway
 */

public class RootStack extends Stack {
    public RootStack(Construct scope) {
        super(scope, "integ-restapi-import-RootStack");

        RestApi restApi = RestApi.Builder.create(this, "RestApi")
                .cloudWatchRole(true)
                .deploy(false)
                .build();
        restApi.root.addMethod("ANY");

        PetsStack petsStack = new PetsStack(this, new ResourceNestedStackProps()
                .restApiId(restApi.getRestApiId())
                .rootResourceId(restApi.getRestApiRootResourceId())
                );
        BooksStack booksStack = new BooksStack(this, new ResourceNestedStackProps()
                .restApiId(restApi.getRestApiId())
                .rootResourceId(restApi.getRestApiRootResourceId())
                );
        new DeployStack(this, new DeployStackProps()
                .restApiId(restApi.getRestApiId())
                .methods(petsStack.methods.concat(booksStack.getMethods()))
                );

        CfnOutput.Builder.create(this, "PetsURL")
                .value(String.format("https://%s.execute-api.%s.amazonaws.com/prod/pets", restApi.getRestApiId(), this.region))
                .build();

        CfnOutput.Builder.create(this, "BooksURL")
                .value(String.format("https://%s.execute-api.%s.amazonaws.com/prod/books", restApi.getRestApiId(), this.region))
                .build();
    }
}

public class ResourceNestedStackProps extends NestedStackProps {
    private String restApiId;
    public String getRestApiId() {
        return this.restApiId;
    }
    public ResourceNestedStackProps restApiId(String restApiId) {
        this.restApiId = restApiId;
        return this;
    }

    private String rootResourceId;
    public String getRootResourceId() {
        return this.rootResourceId;
    }
    public ResourceNestedStackProps rootResourceId(String rootResourceId) {
        this.rootResourceId = rootResourceId;
        return this;
    }
}

public class PetsStack extends NestedStack {
    public final Method[] methods;

    public PetsStack(Construct scope, ResourceNestedStackProps props) {
        super(scope, "integ-restapi-import-PetsStack", props);

        IRestApi api = RestApi.fromRestApiAttributes(this, "RestApi", RestApiAttributes.builder()
                .restApiId(props.getRestApiId())
                .rootResourceId(props.getRootResourceId())
                .build());

        Method method = api.root.addResource("pets").addMethod("GET", MockIntegration.Builder.create()
                .integrationResponses(List.of(IntegrationResponse.builder()
                        .statusCode("200")
                        .build()))
                .passthroughBehavior(PassthroughBehavior.NEVER)
                .requestTemplates(Map.of(
                        "application/json", "{ \"statusCode\": 200 }"))
                .build(), MethodOptions.builder()
                .methodResponses(List.of(MethodResponse.builder().statusCode("200").build()))
                .build());

        this.methods.push(method);
    }
}

public class BooksStack extends NestedStack {
    public final Method[] methods;

    public BooksStack(Construct scope, ResourceNestedStackProps props) {
        super(scope, "integ-restapi-import-BooksStack", props);

        IRestApi api = RestApi.fromRestApiAttributes(this, "RestApi", RestApiAttributes.builder()
                .restApiId(props.getRestApiId())
                .rootResourceId(props.getRootResourceId())
                .build());

        Method method = api.root.addResource("books").addMethod("GET", MockIntegration.Builder.create()
                .integrationResponses(List.of(IntegrationResponse.builder()
                        .statusCode("200")
                        .build()))
                .passthroughBehavior(PassthroughBehavior.NEVER)
                .requestTemplates(Map.of(
                        "application/json", "{ \"statusCode\": 200 }"))
                .build(), MethodOptions.builder()
                .methodResponses(List.of(MethodResponse.builder().statusCode("200").build()))
                .build());

        this.methods.push(method);
    }
}

public class DeployStackProps extends NestedStackProps {
    private String restApiId;
    public String getRestApiId() {
        return this.restApiId;
    }
    public DeployStackProps restApiId(String restApiId) {
        this.restApiId = restApiId;
        return this;
    }

    private Method[] methods;
    public Method[] getMethods() {
        return this.methods;
    }
    public DeployStackProps methods(Method[] methods) {
        this.methods = methods;
        return this;
    }
}

public class DeployStack extends NestedStack {
    public DeployStack(Construct scope, DeployStackProps props) {
        super(scope, "integ-restapi-import-DeployStack", props);

        Deployment deployment = Deployment.Builder.create(this, "Deployment")
                .api(RestApi.fromRestApiId(this, "RestApi", props.getRestApiId()))
                .build();
        if (props.getMethods()) {
            for (Object method : props.getMethods()) {
                deployment.node.addDependency(method);
            }
        }
        Stage.Builder.create(this, "Stage").deployment(deployment).build();
    }
}

new RootStack(new App());
csharp
using Constructs;
using Amazon.CDK;
using Amazon.CDK.AWS.APIGateway;

/**
 * This file showcases how to split up a RestApi's Resources and Methods across nested stacks.
 *
 * The root stack 'RootStack' first defines a RestApi.
 * Two nested stacks BooksStack and PetsStack, create corresponding Resources '/books' and '/pets'.
 * They are then deployed to a 'prod' Stage via a third nested stack - DeployStack.
 *
 * To verify this worked, go to the APIGateway
 */

class RootStack : Stack
{
    public RootStack(Construct scope) : base(scope, "integ-restapi-import-RootStack")
    {

        var restApi = new RestApi(this, "RestApi", new RestApiProps {
            CloudWatchRole = true,
            Deploy = false
        });
        restApi.Root.AddMethod("ANY");

        var petsStack = new PetsStack(this, new ResourceNestedStackProps {
            RestApiId = restApi.RestApiId,
            RootResourceId = restApi.RestApiRootResourceId
        });
        var booksStack = new BooksStack(this, new ResourceNestedStackProps {
            RestApiId = restApi.RestApiId,
            RootResourceId = restApi.RestApiRootResourceId
        });
        new DeployStack(this, new DeployStackProps {
            RestApiId = restApi.RestApiId,
            Methods = petsStack.Methods.Concat(booksStack.Methods)
        });

        new CfnOutput(this, "PetsURL", new CfnOutputProps {
            Value = $"https://{restApi.restApiId}.execute-api.{this.region}.amazonaws.com/prod/pets"
        });

        new CfnOutput(this, "BooksURL", new CfnOutputProps {
            Value = $"https://{restApi.restApiId}.execute-api.{this.region}.amazonaws.com/prod/books"
        });
    }
}

class ResourceNestedStackProps : NestedStackProps
{
    public string RestApiId { get; set; }

    public string RootResourceId { get; set; }
}

class PetsStack : NestedStack
{
    public readonly Method[] Methods = new [] {  };

    public PetsStack(Construct scope, ResourceNestedStackProps props) : base(scope, "integ-restapi-import-PetsStack", props)
    {

        var api = RestApi.FromRestApiAttributes(this, "RestApi", new RestApiAttributes {
            RestApiId = props.RestApiId,
            RootResourceId = props.RootResourceId
        });

        var method = api.Root.AddResource("pets").AddMethod("GET", new MockIntegration(new IntegrationOptions {
            IntegrationResponses = new [] { new IntegrationResponse {
                StatusCode = "200"
            } },
            PassthroughBehavior = PassthroughBehavior.NEVER,
            RequestTemplates = new Dictionary<string, string> {
                { "application/json", "{ \"statusCode\": 200 }" }
            }
        }), new MethodOptions {
            MethodResponses = new [] { new MethodResponse { StatusCode = "200" } }
        });

        Methods.Push(method);
    }
}

class BooksStack : NestedStack
{
    public readonly Method[] Methods = new [] {  };

    public BooksStack(Construct scope, ResourceNestedStackProps props) : base(scope, "integ-restapi-import-BooksStack", props)
    {

        var api = RestApi.FromRestApiAttributes(this, "RestApi", new RestApiAttributes {
            RestApiId = props.RestApiId,
            RootResourceId = props.RootResourceId
        });

        var method = api.Root.AddResource("books").AddMethod("GET", new MockIntegration(new IntegrationOptions {
            IntegrationResponses = new [] { new IntegrationResponse {
                StatusCode = "200"
            } },
            PassthroughBehavior = PassthroughBehavior.NEVER,
            RequestTemplates = new Dictionary<string, string> {
                { "application/json", "{ \"statusCode\": 200 }" }
            }
        }), new MethodOptions {
            MethodResponses = new [] { new MethodResponse { StatusCode = "200" } }
        });

        Methods.Push(method);
    }
}

class DeployStackProps : NestedStackProps
{
    public string RestApiId { get; set; }

    public Method[]? Methods { get; set; }
}

class DeployStack : NestedStack
{
    public DeployStack(Construct scope, DeployStackProps props) : base(scope, "integ-restapi-import-DeployStack", props)
    {

        var deployment = new Deployment(this, "Deployment", new DeploymentProps {
            Api = RestApi.FromRestApiId(this, "RestApi", props.RestApiId)
        });
        if (props.Methods)
        {
            for (var method in props.Methods)
            {
                deployment.Node.AddDependency(method);
            }
        }
        new Stage(this, "Stage", new StageProps { Deployment = deployment });
    }
}

new RootStack(new App());
go
import "github.com/aws/constructs-go/constructs"
import "github.com/aws/aws-cdk-go/awscdk"
import "github.com/aws/aws-cdk-go/awscdk"
import "github.com/aws/aws-cdk-go/awscdk"
import "github.com/aws/aws-cdk-go/awscdk"

/**
 * This file showcases how to split up a RestApi's Resources and Methods across nested stacks.
 *
 * The root stack 'RootStack' first defines a RestApi.
 * Two nested stacks BooksStack and PetsStack, create corresponding Resources '/books' and '/pets'.
 * They are then deployed to a 'prod' Stage via a third nested stack - DeployStack.
 *
 * To verify this worked, go to the APIGateway
 */

type rootStack struct {
	Stack
}

func newRootStack(scope Construct) *rootStack {
	this := &rootStack{}
	newStack_Override(this, scope, jsii.String("integ-restapi-import-RootStack"))

	restApi := awscdk.NewRestApi(this, jsii.String("RestApi"), &RestApiProps{
		CloudWatchRole: jsii.Boolean(true),
		Deploy: jsii.Boolean(false),
	})
	restApi.Root.AddMethod(jsii.String("ANY"))

	petsStack := NewPetsStack(this, &resourceNestedStackProps{
		restApiId: restApi.RestApiId,
		rootResourceId: restApi.RestApiRootResourceId,
	})
	booksStack := NewBooksStack(this, &resourceNestedStackProps{
		restApiId: restApi.*RestApiId,
		rootResourceId: restApi.*RestApiRootResourceId,
	})
	NewDeployStack(this, &deployStackProps{
		restApiId: restApi.*RestApiId,
		methods: petsStack.methods.concat(booksStack.methods),
	})

	awscdk.NewCfnOutput(this, jsii.String("PetsURL"), &CfnOutputProps{
		Value: fmt.Sprintf("https://%v.execute-api.%v.amazonaws.com/prod/pets", restApi.*RestApiId, this.Region),
	})

	awscdk.NewCfnOutput(this, jsii.String("BooksURL"), &CfnOutputProps{
		Value: fmt.Sprintf("https://%v.execute-api.%v.amazonaws.com/prod/books", restApi.*RestApiId, this.*Region),
	})
	return this
}

type resourceNestedStackProps struct {
	NestedStackProps
	restApiId *string
	rootResourceId *string
}

type petsStack struct {
	NestedStack
	methods []Method
}

func newPetsStack(scope Construct, props resourceNestedStackProps) *petsStack {
	this := &petsStack{}
	newNestedStack_Override(this, scope, jsii.String("integ-restapi-import-PetsStack"), props)

	api := awscdk.RestApi_FromRestApiAttributes(this, jsii.String("RestApi"), &RestApiAttributes{
		RestApiId: props.restApiId,
		RootResourceId: props.rootResourceId,
	})

	method := api.Root.AddResource(jsii.String("pets")).AddMethod(jsii.String("GET"), awscdk.NewMockIntegration(&IntegrationOptions{
		IntegrationResponses: []IntegrationResponse{
			&IntegrationResponse{
				StatusCode: jsii.String("200"),
			},
		},
		PassthroughBehavior: awscdk.PassthroughBehavior_NEVER,
		RequestTemplates: map[string]*string{
			"application/json": jsii.String("{ \"statusCode\": 200 }"),
		},
	}), &MethodOptions{
		MethodResponses: []MethodResponse{
			&MethodResponse{
				StatusCode: jsii.String("200"),
			},
		},
	})

	this.methods.push(method)
	return this
}

type booksStack struct {
	NestedStack
	methods []Method
}

func newBooksStack(scope Construct, props resourceNestedStackProps) *booksStack {
	this := &booksStack{}
	newNestedStack_Override(this, scope, jsii.String("integ-restapi-import-BooksStack"), props)

	api := awscdk.RestApi_FromRestApiAttributes(this, jsii.String("RestApi"), &RestApiAttributes{
		RestApiId: props.restApiId,
		RootResourceId: props.rootResourceId,
	})

	method := api.Root.AddResource(jsii.String("books")).AddMethod(jsii.String("GET"), awscdk.NewMockIntegration(&IntegrationOptions{
		IntegrationResponses: []IntegrationResponse{
			&IntegrationResponse{
				StatusCode: jsii.String("200"),
			},
		},
		PassthroughBehavior: awscdk.PassthroughBehavior_NEVER,
		RequestTemplates: map[string]*string{
			"application/json": jsii.String("{ \"statusCode\": 200 }"),
		},
	}), &MethodOptions{
		MethodResponses: []MethodResponse{
			&MethodResponse{
				StatusCode: jsii.String("200"),
			},
		},
	})

	this.methods.push(method)
	return this
}

type deployStackProps struct {
	NestedStackProps
	restApiId *string
	methods []Method
}

type deployStack struct {
	NestedStack
}

func newDeployStack(scope Construct, props deployStackProps) *deployStack {
	this := &deployStack{}
	newNestedStack_Override(this, scope, jsii.String("integ-restapi-import-DeployStack"), props)

	deployment := awscdk.NewDeployment(this, jsii.String("Deployment"), &DeploymentProps{
		Api: awscdk.RestApi_FromRestApiId(this, jsii.String("RestApi"), props.restApiId),
	})
	if *props.methods {
		for _, method := range *props.methods {
			deployment.Node.AddDependency(method)
		}
	}
	awscdk.NewStage(this, jsii.String("Stage"), &StageProps{
		Deployment: Deployment,
	})
	return this
}

NewRootStack(awscdk.NewApp())

Warning: In the code above, an API Gateway deployment is created during the initial CDK deployment. However, if there are changes to the resources in subsequent CDK deployments, a new API Gateway deployment is not automatically created. As a result, the latest state of the resources is not reflected. To ensure the latest state of the resources is reflected, a manual deployment of the API Gateway is required after the CDK deployment. See Controlled triggering of deployments for more info.

AWS Lambda-backed APIs ​

A very common practice is to use Amazon API Gateway with AWS Lambda as the backend integration. The LambdaRestApi construct makes it easy:

The following code defines a REST API that routes all requests to the specified AWS Lambda function:

ts
declare const backend: lambda.Function;
new apigateway.LambdaRestApi(this, 'myapi', {
  handler: backend,
});
python
# backend: lambda.Function

apigateway.LambdaRestApi(self, "myapi",
    handler=backend
)
java
Function backend;

LambdaRestApi.Builder.create(this, "myapi")
        .handler(backend)
        .build();
csharp
Function backend;

new LambdaRestApi(this, "myapi", new LambdaRestApiProps {
    Handler = backend
});
go
var backend Function

apigateway.NewLambdaRestApi(this, jsii.String("myapi"), &LambdaRestApiProps{
	Handler: backend,
})

You can also supply proxy: false, in which case you will have to explicitly define the API model:

ts
declare const backend: lambda.Function;
const api = new apigateway.LambdaRestApi(this, 'myapi', {
  handler: backend,
  proxy: false
});

const items = api.root.addResource('items');
items.addMethod('GET');  // GET /items
items.addMethod('POST'); // POST /items

const item = items.addResource('{item}');
item.addMethod('GET');   // GET /items/{item}

// the default integration for methods is "handler", but one can
// customize this behavior per method or even a sub path.
item.addMethod('DELETE', new apigateway.HttpIntegration('http://amazon.com'));
python
# backend: lambda.Function

api = apigateway.LambdaRestApi(self, "myapi",
    handler=backend,
    proxy=False
)

items = api.root.add_resource("items")
items.add_method("GET") # GET /items
items.add_method("POST") # POST /items

item = items.add_resource("{item}")
item.add_method("GET") # GET /items/{item}

# the default integration for methods is "handler", but one can
# customize this behavior per method or even a sub path.
item.add_method("DELETE", apigateway.HttpIntegration("http://amazon.com"))
java
Function backend;

LambdaRestApi api = LambdaRestApi.Builder.create(this, "myapi")
        .handler(backend)
        .proxy(false)
        .build();

Resource items = api.root.addResource("items");
items.addMethod("GET"); // GET /items
items.addMethod("POST"); // POST /items

Resource item = items.addResource("{item}");
item.addMethod("GET"); // GET /items/{item}

// the default integration for methods is "handler", but one can
// customize this behavior per method or even a sub path.
item.addMethod("DELETE", new HttpIntegration("http://amazon.com"));
csharp
Function backend;

var api = new LambdaRestApi(this, "myapi", new LambdaRestApiProps {
    Handler = backend,
    Proxy = false
});

var items = api.Root.AddResource("items");
items.AddMethod("GET"); // GET /items
items.AddMethod("POST"); // POST /items

var item = items.AddResource("{item}");
item.AddMethod("GET"); // GET /items/{item}

// the default integration for methods is "handler", but one can
// customize this behavior per method or even a sub path.
item.AddMethod("DELETE", new HttpIntegration("http://amazon.com"));
go
var backend Function

api := apigateway.NewLambdaRestApi(this, jsii.String("myapi"), &LambdaRestApiProps{
	Handler: backend,
	Proxy: jsii.Boolean(false),
})

items := api.Root.AddResource(jsii.String("items"))
items.AddMethod(jsii.String("GET")) // GET /items
items.AddMethod(jsii.String("POST")) // POST /items

item := items.AddResource(jsii.String("{item}"))
item.AddMethod(jsii.String("GET")) // GET /items/{item}

// the default integration for methods is "handler", but one can
// customize this behavior per method or even a sub path.
item.AddMethod(jsii.String("DELETE"), apigateway.NewHttpIntegration(jsii.String("http://amazon.com")))

Additionally, integrationOptions can be supplied to explicitly define options of the Lambda integration:

ts
declare const backend: lambda.Function;

const api = new apigateway.LambdaRestApi(this, 'myapi', {
  handler: backend,
  integrationOptions: {
    allowTestInvoke: false,
    timeout: Duration.seconds(1),
  }
})
python
# backend: lambda.Function


api = apigateway.LambdaRestApi(self, "myapi",
    handler=backend,
    integration_options=apigateway.LambdaIntegrationOptions(
        allow_test_invoke=False,
        timeout=Duration.seconds(1)
    )
)
java
Function backend;


LambdaRestApi api = LambdaRestApi.Builder.create(this, "myapi")
        .handler(backend)
        .integrationOptions(LambdaIntegrationOptions.builder()
                .allowTestInvoke(false)
                .timeout(Duration.seconds(1))
                .build())
        .build();
csharp
Function backend;


var api = new LambdaRestApi(this, "myapi", new LambdaRestApiProps {
    Handler = backend,
    IntegrationOptions = new LambdaIntegrationOptions {
        AllowTestInvoke = false,
        Timeout = Duration.Seconds(1)
    }
});
go
var backend Function


api := apigateway.NewLambdaRestApi(this, jsii.String("myapi"), &LambdaRestApiProps{
	Handler: backend,
	IntegrationOptions: &LambdaIntegrationOptions{
		AllowTestInvoke: jsii.Boolean(false),
		Timeout: awscdk.Duration_Seconds(jsii.Number(1)),
	},
})

AWS StepFunctions backed APIs ​

You can use Amazon API Gateway with AWS Step Functions as the backend integration, specifically Synchronous Express Workflows.

The StepFunctionsRestApi only supports integration with Synchronous Express state machine. The StepFunctionsRestApi construct makes this easy by setting up input, output and error mapping.

The construct sets up an API endpoint and maps the ANY HTTP method and any calls to the API endpoint starts an express workflow execution for the underlying state machine.

Invoking the endpoint with any HTTP method (GET, POST, PUT, DELETE, ...) in the example below will send the request to the state machine as a new execution. On success, an HTTP code 200 is returned with the execution output as the Response Body.

If the execution fails, an HTTP 500 response is returned with the error and cause from the execution output as the Response Body. If the request is invalid (ex. bad execution input) HTTP code 400 is returned.

To disable default response models generation use the useDefaultMethodResponses property:

ts
declare const machine: stepfunctions.IStateMachine;

new apigateway.StepFunctionsRestApi(this, 'StepFunctionsRestApi', {
  stateMachine: machine,
  useDefaultMethodResponses: false,
});
python
# machine: stepfunctions.IStateMachine


apigateway.StepFunctionsRestApi(self, "StepFunctionsRestApi",
    state_machine=machine,
    use_default_method_responses=False
)
java
IStateMachine machine;


StepFunctionsRestApi.Builder.create(this, "StepFunctionsRestApi")
        .stateMachine(machine)
        .useDefaultMethodResponses(false)
        .build();
csharp
IStateMachine machine;


new StepFunctionsRestApi(this, "StepFunctionsRestApi", new StepFunctionsRestApiProps {
    StateMachine = machine,
    UseDefaultMethodResponses = false
});
go
var machine IStateMachine


apigateway.NewStepFunctionsRestApi(this, jsii.String("StepFunctionsRestApi"), &StepFunctionsRestApiProps{
	StateMachine: machine,
	UseDefaultMethodResponses: jsii.Boolean(false),
})

The response from the invocation contains only the output field from the StartSyncExecution API. In case of failures, the fields error and cause are returned as part of the response. Other metadata such as billing details, AWS account ID and resource ARNs are not returned in the API response.

By default, a prod stage is provisioned.

In order to reduce the payload size sent to AWS Step Functions, headers are not forwarded to the Step Functions execution input. It is possible to choose whether headers, requestContext, path, querystring, and authorizer are included or not. By default, headers are excluded in all requests.

More details about AWS Step Functions payload limit can be found at https://docs.aws.amazon.com/step-functions/latest/dg/limits-overview.html#service-limits-task-executions.

The following code defines a REST API that routes all requests to the specified AWS StepFunctions state machine:

ts
const stateMachineDefinition = new stepfunctions.Pass(this, 'PassState');

const stateMachine: stepfunctions.IStateMachine = new stepfunctions.StateMachine(this, 'StateMachine', {
  definition: stateMachineDefinition,
  stateMachineType: stepfunctions.StateMachineType.EXPRESS,
});

new apigateway.StepFunctionsRestApi(this, 'StepFunctionsRestApi', {
  deploy: true,
  stateMachine: stateMachine,
});
python
state_machine_definition = stepfunctions.Pass(self, "PassState")

state_machine = stepfunctions.StateMachine(self, "StateMachine",
    definition=state_machine_definition,
    state_machine_type=stepfunctions.StateMachineType.EXPRESS
)

apigateway.StepFunctionsRestApi(self, "StepFunctionsRestApi",
    deploy=True,
    state_machine=state_machine
)
java
Pass stateMachineDefinition = new Pass(this, "PassState");

IStateMachine stateMachine = StateMachine.Builder.create(this, "StateMachine")
        .definition(stateMachineDefinition)
        .stateMachineType(StateMachineType.EXPRESS)
        .build();

StepFunctionsRestApi.Builder.create(this, "StepFunctionsRestApi")
        .deploy(true)
        .stateMachine(stateMachine)
        .build();
csharp
var stateMachineDefinition = new Pass(this, "PassState");

var stateMachine = new StateMachine(this, "StateMachine", new StateMachineProps {
    Definition = stateMachineDefinition,
    StateMachineType = StateMachineType.EXPRESS
});

new StepFunctionsRestApi(this, "StepFunctionsRestApi", new StepFunctionsRestApiProps {
    Deploy = true,
    StateMachine = stateMachine
});
go
stateMachineDefinition := stepfunctions.NewPass(this, jsii.String("PassState"))

stateMachine := stepfunctions.NewStateMachine(this, jsii.String("StateMachine"), &StateMachineProps{
	Definition: stateMachineDefinition,
	StateMachineType: stepfunctions.StateMachineType_EXPRESS,
})

apigateway.NewStepFunctionsRestApi(this, jsii.String("StepFunctionsRestApi"), &StepFunctionsRestApiProps{
	Deploy: jsii.Boolean(true),
	StateMachine: stateMachine,
})

When the REST API endpoint configuration above is invoked using POST, as follows -

bash
curl -X POST -d '{ "customerId": 1 }' https://example.com/

AWS Step Functions will receive the request body in its input as follows:

json
{
  "body": {
    "customerId": 1
  },
  "path": "/",
  "querystring": {}
}

When the endpoint is invoked at path '/users/5' using the HTTP GET method as below:

bash
curl -X GET https://example.com/users/5?foo=bar

AWS Step Functions will receive the following execution input:

json
{
  "body": {},
  "path": {
     "users": "5"
  },
  "querystring": {
    "foo": "bar"
  }
}

Additional information around the request such as the request context, authorizer context, and headers can be included as part of the input forwarded to the state machine. The following example enables headers to be included in the input but not query string.

ts
new apigateway.StepFunctionsRestApi(this, 'StepFunctionsRestApi', {
  stateMachine: machine,
  headers: true,
  path: false,
  querystring: false,
  authorizer: false,
  requestContext: {
    caller: true,
    user: true,
  },
});
python
apigateway.StepFunctionsRestApi(self, "StepFunctionsRestApi",
    state_machine=machine,
    headers=True,
    path=False,
    querystring=False,
    authorizer=False,
    request_context=apigateway.RequestContext(
        caller=True,
        user=True
    )
)
java
StepFunctionsRestApi.Builder.create(this, "StepFunctionsRestApi")
        .stateMachine(machine)
        .headers(true)
        .path(false)
        .querystring(false)
        .authorizer(false)
        .requestContext(RequestContext.builder()
                .caller(true)
                .user(true)
                .build())
        .build();
csharp
new StepFunctionsRestApi(this, "StepFunctionsRestApi", new StepFunctionsRestApiProps {
    StateMachine = machine,
    Headers = true,
    Path = false,
    Querystring = false,
    Authorizer = false,
    RequestContext = new RequestContext {
        Caller = true,
        User = true
    }
});
go
apigateway.NewStepFunctionsRestApi(this, jsii.String("StepFunctionsRestApi"), &StepFunctionsRestApiProps{
	StateMachine: machine,
	Headers: jsii.Boolean(true),
	Path: jsii.Boolean(false),
	Querystring: jsii.Boolean(false),
	Authorizer: jsii.Boolean(false),
	RequestContext: &RequestContext{
		Caller: jsii.Boolean(true),
		User: jsii.Boolean(true),
	},
})

In such a case, when the endpoint is invoked as below:

bash
curl -X GET https://example.com/

AWS Step Functions will receive the following execution input:

json
{
  "headers": {
    "Accept": "...",
    "CloudFront-Forwarded-Proto": "...",
  },
  "requestContext": {
     "accountId": "...",
     "apiKey": "...",
  },
  "body": {}
}

Integration Targets ​

Methods are associated with backend integrations, which are invoked when this method is called. API Gateway supports the following integrations:

  • MockIntegration - can be used to test APIs. This is the default integration if one is not specified.
  • AwsIntegration - can be used to invoke arbitrary AWS service APIs.
  • HttpIntegration - can be used to invoke HTTP endpoints.
  • LambdaIntegration - can be used to invoke an AWS Lambda function.
  • SagemakerIntegration - can be used to invoke Sagemaker Endpoints.

The following example shows how to integrate the GET /book/{book_id} method to an AWS Lambda function:

ts
declare const getBookHandler: lambda.Function;
declare const book: apigateway.Resource;

const getBookIntegration = new apigateway.LambdaIntegration(getBookHandler);
book.addMethod('GET', getBookIntegration);
python
# get_book_handler: lambda.Function
# book: apigateway.Resource


get_book_integration = apigateway.LambdaIntegration(get_book_handler)
book.add_method("GET", get_book_integration)
java
Function getBookHandler;
Resource book;


LambdaIntegration getBookIntegration = new LambdaIntegration(getBookHandler);
book.addMethod("GET", getBookIntegration);
csharp
Function getBookHandler;
Resource book;


var getBookIntegration = new LambdaIntegration(getBookHandler);
book.AddMethod("GET", getBookIntegration);
go
var getBookHandler Function
var book Resource


getBookIntegration := apigateway.NewLambdaIntegration(getBookHandler)
book.AddMethod(jsii.String("GET"), getBookIntegration)

Integration options can be optionally be specified:

ts
declare const getBookHandler: lambda.Function;
declare const getBookIntegration: apigateway.LambdaIntegration;

const getBookIntegration = new apigateway.LambdaIntegration(getBookHandler, {
  contentHandling: apigateway.ContentHandling.CONVERT_TO_TEXT, // convert to base64
  credentialsPassthrough: true, // use caller identity to invoke the function
});
python
# get_book_handler: lambda.Function
# get_book_integration: apigateway.LambdaIntegration


get_book_integration = apigateway.LambdaIntegration(get_book_handler,
    content_handling=apigateway.ContentHandling.CONVERT_TO_TEXT,  # convert to base64
    credentials_passthrough=True
)
java
Function getBookHandler;
LambdaIntegration getBookIntegration;


LambdaIntegration getBookIntegration = LambdaIntegration.Builder.create(getBookHandler)
        .contentHandling(ContentHandling.CONVERT_TO_TEXT) // convert to base64
        .credentialsPassthrough(true)
        .build();
csharp
Function getBookHandler;
LambdaIntegration getBookIntegration;


var getBookIntegration = new LambdaIntegration(getBookHandler, new LambdaIntegrationOptions {
    ContentHandling = ContentHandling.CONVERT_TO_TEXT,  // convert to base64
    CredentialsPassthrough = true
});
go
var getBookHandler Function
var getBookIntegration LambdaIntegration


getBookIntegration := apigateway.NewLambdaIntegration(getBookHandler, &LambdaIntegrationOptions{
	ContentHandling: apigateway.ContentHandling_CONVERT_TO_TEXT,
	 // convert to base64
	CredentialsPassthrough: jsii.Boolean(true),
})

Method options can optionally be specified when adding methods:

ts
declare const book: apigateway.Resource;
declare const getBookIntegration: apigateway.LambdaIntegration;

book.addMethod('GET', getBookIntegration, {
  authorizationType: apigateway.AuthorizationType.IAM,
  apiKeyRequired: true
});
python
# book: apigateway.Resource
# get_book_integration: apigateway.LambdaIntegration


book.add_method("GET", get_book_integration,
    authorization_type=apigateway.AuthorizationType.IAM,
    api_key_required=True
)
java
Resource book;
LambdaIntegration getBookIntegration;


book.addMethod("GET", getBookIntegration, MethodOptions.builder()
        .authorizationType(AuthorizationType.IAM)
        .apiKeyRequired(true)
        .build());
csharp
Resource book;
LambdaIntegration getBookIntegration;


book.AddMethod("GET", getBookIntegration, new MethodOptions {
    AuthorizationType = AuthorizationType.IAM,
    ApiKeyRequired = true
});
go
var book Resource
var getBookIntegration LambdaIntegration


book.AddMethod(jsii.String("GET"), getBookIntegration, &MethodOptions{
	AuthorizationType: apigateway.AuthorizationType_IAM,
	ApiKeyRequired: jsii.Boolean(true),
})

It is possible to also integrate with AWS services in a different region. The following code integrates with Amazon SQS in the eu-west-1 region.

ts
const getMessageIntegration = new apigateway.AwsIntegration({
  service: 'sqs',
  path: 'queueName',
  region: 'eu-west-1'
});
python
get_message_integration = apigateway.AwsIntegration(
    service="sqs",
    path="queueName",
    region="eu-west-1"
)
java
AwsIntegration getMessageIntegration = AwsIntegration.Builder.create()
        .service("sqs")
        .path("queueName")
        .region("eu-west-1")
        .build();
csharp
var getMessageIntegration = new AwsIntegration(new AwsIntegrationProps {
    Service = "sqs",
    Path = "queueName",
    Region = "eu-west-1"
});
go
getMessageIntegration := apigateway.NewAwsIntegration(&AwsIntegrationProps{
	Service: jsii.String("sqs"),
	Path: jsii.String("queueName"),
	Region: jsii.String("eu-west-1"),
})

Response Streaming ​

Integrations support response streaming, which allows responses to be streamed back to clients. This is useful for large payloads or when you want to start sending data before the entire response is ready.

To enable response streaming, set ResponseTransferMode.STREAM to the responseTransferMode option:

ts
declare const handler: lambda.Function;
new apigateway.LambdaIntegration(handler, {
  responseTransferMode: apigateway.ResponseTransferMode.STREAM,
});
python
# handler: lambda.Function

apigateway.LambdaIntegration(handler,
    response_transfer_mode=apigateway.ResponseTransferMode.STREAM
)
java
Function handler;

LambdaIntegration.Builder.create(handler)
        .responseTransferMode(ResponseTransferMode.STREAM)
        .build();
csharp
Function handler;

new LambdaIntegration(handler, new LambdaIntegrationOptions {
    ResponseTransferMode = ResponseTransferMode.STREAM
});
go
var handler Function

apigateway.NewLambdaIntegration(handler, &LambdaIntegrationOptions{
	ResponseTransferMode: apigateway.ResponseTransferMode_STREAM,
})

Lambda Integration Permissions ​

By default, creating a LambdaIntegration will add a permission for API Gateway to invoke your AWS Lambda function, scoped to the specific method which uses the integration.

If you reuse the same AWS Lambda function for many integrations, the AWS Lambda permission policy size can be exceeded by adding a separate policy statement for each method which invokes the AWS Lambda function. To avoid this, you can opt to scope permissions to any method on the API by setting scopePermissionToMethod to false, and this will ensure only a single policy statement is added to the AWS Lambda permission policy.

ts
declare const book: apigateway.Resource;
declare const backend: lambda.Function;

const getBookIntegration = new apigateway.LambdaIntegration(backend, {
  scopePermissionToMethod: false,
});
const createBookIntegration = new apigateway.LambdaIntegration(backend, {
  scopePermissionToMethod: false,
});

book.addMethod('GET', getBookIntegration);
book.addMethod('POST', createBookIntegration);
python
# book: apigateway.Resource
# backend: lambda.Function


get_book_integration = apigateway.LambdaIntegration(backend,
    scope_permission_to_method=False
)
create_book_integration = apigateway.LambdaIntegration(backend,
    scope_permission_to_method=False
)

book.add_method("GET", get_book_integration)
book.add_method("POST", create_book_integration)
java
Resource book;
Function backend;


LambdaIntegration getBookIntegration = LambdaIntegration.Builder.create(backend)
        .scopePermissionToMethod(false)
        .build();
LambdaIntegration createBookIntegration = LambdaIntegration.Builder.create(backend)
        .scopePermissionToMethod(false)
        .build();

book.addMethod("GET", getBookIntegration);
book.addMethod("POST", createBookIntegration);
csharp
Resource book;
Function backend;


var getBookIntegration = new LambdaIntegration(backend, new LambdaIntegrationOptions {
    ScopePermissionToMethod = false
});
var createBookIntegration = new LambdaIntegration(backend, new LambdaIntegrationOptions {
    ScopePermissionToMethod = false
});

book.AddMethod("GET", getBookIntegration);
book.AddMethod("POST", createBookIntegration);
go
var book Resource
var backend Function


getBookIntegration := apigateway.NewLambdaIntegration(backend, &LambdaIntegrationOptions{
	ScopePermissionToMethod: jsii.Boolean(false),
})
createBookIntegration := apigateway.NewLambdaIntegration(backend, &LambdaIntegrationOptions{
	ScopePermissionToMethod: jsii.Boolean(false),
})

book.AddMethod(jsii.String("GET"), getBookIntegration)
book.AddMethod(jsii.String("POST"), createBookIntegration)

In the above example, a single permission is added, shared by both getBookIntegration and createBookIntegration.

Note that setting scopePermissionToMethod to false will always allow test invocations, no matter the value specified for allowTestInvoke.

Usage Plan & API Keys ​

A usage plan specifies who can access one or more deployed API stages and methods, and the rate at which they can be accessed. The plan uses API keys to identify API clients and meters access to the associated API stages for each key. Usage plans also allow configuring throttling limits and quota limits that are enforced on individual client API keys.

The following example shows how to create and associate a usage plan and an API key:

ts
declare const integration: apigateway.LambdaIntegration;

const api = new apigateway.RestApi(this, 'hello-api');

const v1 = api.root.addResource('v1');
const echo = v1.addResource('echo');
const echoMethod = echo.addMethod('GET', integration, { apiKeyRequired: true });

const plan = api.addUsagePlan('UsagePlan', {
  name: 'Easy',
  throttle: {
    rateLimit: 10,
    burstLimit: 2
  }
});

const key = api.addApiKey('ApiKey');
plan.addApiKey(key);
python
# integration: apigateway.LambdaIntegration


api = apigateway.RestApi(self, "hello-api")

v1 = api.root.add_resource("v1")
echo = v1.add_resource("echo")
echo_method = echo.add_method("GET", integration, api_key_required=True)

plan = api.add_usage_plan("UsagePlan",
    name="Easy",
    throttle=apigateway.ThrottleSettings(
        rate_limit=10,
        burst_limit=2
    )
)

key = api.add_api_key("ApiKey")
plan.add_api_key(key)
java
LambdaIntegration integration;


RestApi api = new RestApi(this, "hello-api");

Resource v1 = api.root.addResource("v1");
Resource echo = v1.addResource("echo");
Method echoMethod = echo.addMethod("GET", integration, MethodOptions.builder().apiKeyRequired(true).build());

UsagePlan plan = api.addUsagePlan("UsagePlan", UsagePlanProps.builder()
        .name("Easy")
        .throttle(ThrottleSettings.builder()
                .rateLimit(10)
                .burstLimit(2)
                .build())
        .build());

IApiKey key = api.addApiKey("ApiKey");
plan.addApiKey(key);
csharp
LambdaIntegration integration;


var api = new RestApi(this, "hello-api");

var v1 = api.Root.AddResource("v1");
var echo = v1.AddResource("echo");
var echoMethod = echo.AddMethod("GET", integration, new MethodOptions { ApiKeyRequired = true });

var plan = api.AddUsagePlan("UsagePlan", new UsagePlanProps {
    Name = "Easy",
    Throttle = new ThrottleSettings {
        RateLimit = 10,
        BurstLimit = 2
    }
});

var key = api.AddApiKey("ApiKey");
plan.AddApiKey(key);
go
var integration LambdaIntegration


api := apigateway.NewRestApi(this, jsii.String("hello-api"))

v1 := api.Root.AddResource(jsii.String("v1"))
echo := v1.AddResource(jsii.String("echo"))
echoMethod := echo.AddMethod(jsii.String("GET"), integration, &MethodOptions{
	ApiKeyRequired: jsii.Boolean(true),
})

plan := api.AddUsagePlan(jsii.String("UsagePlan"), &UsagePlanProps{
	Name: jsii.String("Easy"),
	Throttle: &ThrottleSettings{
		RateLimit: jsii.Number(10),
		BurstLimit: jsii.Number(2),
	},
})

key := api.AddApiKey(jsii.String("ApiKey"))
plan.addApiKey(key)

To associate a plan to a given RestAPI stage:

ts
declare const plan: apigateway.UsagePlan;
declare const api: apigateway.RestApi;
declare const echoMethod: apigateway.Method;

plan.addApiStage({
  stage: api.deploymentStage,
  throttle: [
    {
      method: echoMethod,
      throttle: {
        rateLimit: 10,
        burstLimit: 2
      }
    }
  ]
});
python
# plan: apigateway.UsagePlan
# api: apigateway.RestApi
# echo_method: apigateway.Method


plan.add_api_stage(
    stage=api.deployment_stage,
    throttle=[apigateway.ThrottlingPerMethod(
        method=echo_method,
        throttle=apigateway.ThrottleSettings(
            rate_limit=10,
            burst_limit=2
        )
    )
    ]
)
java
UsagePlan plan;
RestApi api;
Method echoMethod;


plan.addApiStage(UsagePlanPerApiStage.builder()
        .stage(api.getDeploymentStage())
        .throttle(List.of(ThrottlingPerMethod.builder()
                .method(echoMethod)
                .throttle(ThrottleSettings.builder()
                        .rateLimit(10)
                        .burstLimit(2)
                        .build())
                .build()))
        .build());
csharp
UsagePlan plan;
RestApi api;
Method echoMethod;


plan.AddApiStage(new UsagePlanPerApiStage {
    Stage = api.DeploymentStage,
    Throttle = new [] { new ThrottlingPerMethod {
        Method = echoMethod,
        Throttle = new ThrottleSettings {
            RateLimit = 10,
            BurstLimit = 2
        }
    } }
});
go
var plan UsagePlan
var api RestApi
var echoMethod Method


plan.AddApiStage(&UsagePlanPerApiStage{
	Stage: api.DeploymentStage,
	Throttle: []ThrottlingPerMethod{
		&ThrottlingPerMethod{
			Method: echoMethod,
			Throttle: &ThrottleSettings{
				RateLimit: jsii.Number(10),
				BurstLimit: jsii.Number(2),
			},
		},
	},
})

Existing usage plans can be imported into a CDK app using its id.

ts
const importedUsagePlan = apigateway.UsagePlan.fromUsagePlanId(this, 'imported-usage-plan', '<usage-plan-key-id>');
python
imported_usage_plan = apigateway.UsagePlan.from_usage_plan_id(self, "imported-usage-plan", "<usage-plan-key-id>")
java
IUsagePlan importedUsagePlan = UsagePlan.fromUsagePlanId(this, "imported-usage-plan", "<usage-plan-key-id>");
csharp
var importedUsagePlan = UsagePlan.FromUsagePlanId(this, "imported-usage-plan", "<usage-plan-key-id>");
go
importedUsagePlan := apigateway.UsagePlan_FromUsagePlanId(this, jsii.String("imported-usage-plan"), jsii.String("<usage-plan-key-id>"))

The name and value of the API Key can be specified at creation; if not provided, a name and value will be automatically generated by API Gateway.

ts
declare const api: apigateway.RestApi;
const key = api.addApiKey('ApiKey', {
  apiKeyName: 'myApiKey1',
  value: 'MyApiKeyThatIsAtLeast20Characters',
});
python
# api: apigateway.RestApi

key = api.add_api_key("ApiKey",
    api_key_name="myApiKey1",
    value="MyApiKeyThatIsAtLeast20Characters"
)
java
RestApi api;

IApiKey key = api.addApiKey("ApiKey", ApiKeyOptions.builder()
        .apiKeyName("myApiKey1")
        .value("MyApiKeyThatIsAtLeast20Characters")
        .build());
csharp
RestApi api;

var key = api.AddApiKey("ApiKey", new ApiKeyOptions {
    ApiKeyName = "myApiKey1",
    Value = "MyApiKeyThatIsAtLeast20Characters"
});
go
var api RestApi

key := api.AddApiKey(jsii.String("ApiKey"), &ApiKeyOptions{
	ApiKeyName: jsii.String("myApiKey1"),
	Value: jsii.String("MyApiKeyThatIsAtLeast20Characters"),
})

Existing API keys can also be imported into a CDK app using its id.

ts
const importedKey = apigateway.ApiKey.fromApiKeyId(this, 'imported-key', '<api-key-id>');
python
imported_key = apigateway.ApiKey.from_api_key_id(self, "imported-key", "<api-key-id>")
java
IApiKey importedKey = ApiKey.fromApiKeyId(this, "imported-key", "<api-key-id>");
csharp
var importedKey = ApiKey.FromApiKeyId(this, "imported-key", "<api-key-id>");
go
importedKey := apigateway.ApiKey_FromApiKeyId(this, jsii.String("imported-key"), jsii.String("<api-key-id>"))

The "grant" methods can be used to give prepackaged sets of permissions to other resources. The following code provides read permission to an API key.

ts
declare const importedKey: apigateway.ApiKey;
declare const lambdaFn: lambda.Function;
importedKey.grantRead(lambdaFn);
python
# imported_key: apigateway.ApiKey
# lambda_fn: lambda.Function

imported_key.grant_read(lambda_fn)
java
ApiKey importedKey;
Function lambdaFn;

importedKey.grantRead(lambdaFn);
csharp
ApiKey importedKey;
Function lambdaFn;

importedKey.GrantRead(lambdaFn);
go
var importedKey ApiKey
var lambdaFn Function

importedKey.grantRead(lambdaFn)

Adding an API Key to an imported RestApi ​

API Keys are added to ApiGateway Stages, not to the API itself. When you import a RestApi it does not have any information on the Stages that may be associated with it. Since adding an API Key requires a stage, you should instead add the Api Key to the imported Stage.

ts
declare const restApi: apigateway.IRestApi;
const importedStage = apigateway.Stage.fromStageAttributes(this, 'imported-stage', {
  stageName: 'myStageName',
  restApi,
});

importedStage.addApiKey('MyApiKey');
python
# rest_api: apigateway.IRestApi

imported_stage = apigateway.Stage.from_stage_attributes(self, "imported-stage",
    stage_name="myStageName",
    rest_api=rest_api
)

imported_stage.add_api_key("MyApiKey")
java
IRestApi restApi;

IStage importedStage = Stage.fromStageAttributes(this, "imported-stage", StageAttributes.builder()
        .stageName("myStageName")
        .restApi(restApi)
        .build());

importedStage.addApiKey("MyApiKey");
csharp
IRestApi restApi;

var importedStage = Stage.FromStageAttributes(this, "imported-stage", new StageAttributes {
    StageName = "myStageName",
    RestApi = restApi
});

importedStage.AddApiKey("MyApiKey");
go
var restApi IRestApi

importedStage := apigateway.Stage_FromStageAttributes(this, jsii.String("imported-stage"), &StageAttributes{
	StageName: jsii.String("myStageName"),
	RestApi: RestApi,
})

importedStage.AddApiKey(jsii.String("MyApiKey"))

⚠️ Multiple API Keys ​

It is possible to specify multiple API keys for a given Usage Plan, by calling usagePlan.addApiKey().

When using multiple API keys, a past bug of the CDK prevents API key associations to a Usage Plan to be deleted. If the CDK app had the feature flag - @aws-cdk/aws-apigateway:usagePlanKeyOrderInsensitiveId - enabled when the API keys were created, then the app will not be affected by this bug.

If this is not the case, you will need to ensure that the CloudFormation logical ids of the API keys that are not being deleted remain unchanged. Make note of the logical ids of these API keys before removing any, and set it as part of the addApiKey() method:

ts
declare const usageplan: apigateway.UsagePlan;
declare const apiKey: apigateway.ApiKey;

usageplan.addApiKey(apiKey, {
  overrideLogicalId: '...',
});
python
# usageplan: apigateway.UsagePlan
# api_key: apigateway.ApiKey


usageplan.add_api_key(api_key,
    override_logical_id="..."
)
java
UsagePlan usageplan;
ApiKey apiKey;


usageplan.addApiKey(apiKey, AddApiKeyOptions.builder()
        .overrideLogicalId("...")
        .build());
csharp
UsagePlan usageplan;
ApiKey apiKey;


usageplan.AddApiKey(apiKey, new AddApiKeyOptions {
    OverrideLogicalId = "..."
});
go
var usageplan UsagePlan
var apiKey ApiKey


usageplan.addApiKey(apiKey, &AddApiKeyOptions{
	OverrideLogicalId: jsii.String("..."),
})

Rate Limited API Key ​

In scenarios where you need to create a single api key and configure rate limiting for it, you can use RateLimitedApiKey. This construct lets you specify rate limiting properties which should be applied only to the api key being created. The API key created has the specified rate limits, such as quota and throttles, applied.

The following example shows how to use a rate limited api key :

ts
declare const api: apigateway.RestApi;

const key = new apigateway.RateLimitedApiKey(this, 'rate-limited-api-key', {
  customerId: 'hello-customer',
  apiStages: [{ stage: api.deploymentStage }],
  quota: {
    limit: 10000,
    period: apigateway.Period.MONTH
  }
});
python
# api: apigateway.RestApi


key = apigateway.RateLimitedApiKey(self, "rate-limited-api-key",
    customer_id="hello-customer",
    api_stages=[apigateway.UsagePlanPerApiStage(stage=api.deployment_stage)],
    quota=apigateway.QuotaSettings(
        limit=10000,
        period=apigateway.Period.MONTH
    )
)
java
RestApi api;


RateLimitedApiKey key = RateLimitedApiKey.Builder.create(this, "rate-limited-api-key")
        .customerId("hello-customer")
        .apiStages(List.of(UsagePlanPerApiStage.builder().stage(api.getDeploymentStage()).build()))
        .quota(QuotaSettings.builder()
                .limit(10000)
                .period(Period.MONTH)
                .build())
        .build();
csharp
RestApi api;


var key = new RateLimitedApiKey(this, "rate-limited-api-key", new RateLimitedApiKeyProps {
    CustomerId = "hello-customer",
    ApiStages = new [] { new UsagePlanPerApiStage { Stage = api.DeploymentStage } },
    Quota = new QuotaSettings {
        Limit = 10000,
        Period = Period.MONTH
    }
});
go
var api RestApi


key := apigateway.NewRateLimitedApiKey(this, jsii.String("rate-limited-api-key"), &RateLimitedApiKeyProps{
	CustomerId: jsii.String("hello-customer"),
	ApiStages: []UsagePlanPerApiStage{
		&UsagePlanPerApiStage{
			Stage: api.DeploymentStage,
		},
	},
	Quota: &QuotaSettings{
		Limit: jsii.Number(10000),
		Period: apigateway.Period_MONTH,
	},
})

Working with models ​

When you work with Lambda integrations that are not Proxy integrations, you have to define your models and mappings for the request, response, and integration.

ts
const hello = new lambda.Function(this, 'hello', {
  runtime: lambda.Runtime.NODEJS_LATEST,
  handler: 'hello.handler',
  code: lambda.Code.fromAsset('lambda')
});

const api = new apigateway.RestApi(this, 'hello-api', { });
const resource = api.root.addResource('v1');
python
hello = lambda_.Function(self, "hello",
    runtime=lambda_.Runtime.NODEJS_LATEST,
    handler="hello.handler",
    code=lambda_.Code.from_asset("lambda")
)

api = apigateway.RestApi(self, "hello-api")
resource = api.root.add_resource("v1")
java
Function hello = Function.Builder.create(this, "hello")
        .runtime(Runtime.NODEJS_LATEST)
        .handler("hello.handler")
        .code(Code.fromAsset("lambda"))
        .build();

RestApi api = RestApi.Builder.create(this, "hello-api").build();
Resource resource = api.root.addResource("v1");
csharp
var hello = new Function(this, "hello", new FunctionProps {
    Runtime = Runtime.NODEJS_LATEST,
    Handler = "hello.handler",
    Code = Code.FromAsset("lambda")
});

var api = new RestApi(this, "hello-api", new RestApiProps { });
var resource = api.Root.AddResource("v1");
go
hello := lambda.NewFunction(this, jsii.String("hello"), &FunctionProps{
	Runtime: lambda.Runtime_NODEJS_LATEST(),
	Handler: jsii.String("hello.handler"),
	Code: lambda.Code_FromAsset(jsii.String("lambda")),
})

api := apigateway.NewRestApi(this, jsii.String("hello-api"), &RestApiProps{
})
resource := api.Root.AddResource(jsii.String("v1"))

You can define more parameters on the integration to tune the behavior of API Gateway

ts
declare const hello: lambda.Function;

const integration = new apigateway.LambdaIntegration(hello, {
  proxy: false,
  requestParameters: {
    // You can define mapping parameters from your method to your integration
    // - Destination parameters (the key) are the integration parameters (used in mappings)
    // - Source parameters (the value) are the source request parameters or expressions
    // @see: https://docs.aws.amazon.com/apigateway/latest/developerguide/request-response-data-mappings.html
    'integration.request.querystring.who': 'method.request.querystring.who'
  },
  allowTestInvoke: true,
  requestTemplates: {
    // You can define a mapping that will build a payload for your integration, based
    //  on the integration parameters that you have specified
    // Check: https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
    'application/json': JSON.stringify({ action: 'sayHello', pollId: "$util.escapeJavaScript($input.params('who'))" })
  },
  // This parameter defines the behavior of the engine is no suitable response template is found
  passthroughBehavior: apigateway.PassthroughBehavior.NEVER,
  integrationResponses: [
    {
      // Successful response from the Lambda function, no filter defined
      //  - the selectionPattern filter only tests the error message
      // We will set the response status code to 200
      statusCode: "200",
      responseTemplates: {
        // This template takes the "message" result from the Lambda function, and embeds it in a JSON response
        // Check https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
        'application/json': JSON.stringify({ state: 'ok', greeting: '$util.escapeJavaScript($input.body)' })
      },
      responseParameters: {
        // We can map response parameters
        // - Destination parameters (the key) are the response parameters (used in mappings)
        // - Source parameters (the value) are the integration response parameters or expressions
        'method.response.header.Content-Type': "'application/json'",
        'method.response.header.Access-Control-Allow-Origin': "'*'",
        'method.response.header.Access-Control-Allow-Credentials': "'true'"
      }
    },
    {
      // For errors, we check if the error message is not empty, get the error data
      selectionPattern: '(\n|.)+',
      // We will set the response status code to 200
      statusCode: "400",
      responseTemplates: {
          'application/json': JSON.stringify({ state: 'error', message: "$util.escapeJavaScript($input.path('$.errorMessage'))" })
      },
      responseParameters: {
          'method.response.header.Content-Type': "'application/json'",
          'method.response.header.Access-Control-Allow-Origin': "'*'",
          'method.response.header.Access-Control-Allow-Credentials': "'true'"
      }
    }
  ]
});
python
# hello: lambda.Function


integration = apigateway.LambdaIntegration(hello,
    proxy=False,
    request_parameters={
        # You can define mapping parameters from your method to your integration
        # - Destination parameters (the key) are the integration parameters (used in mappings)
        # - Source parameters (the value) are the source request parameters or expressions
        # @see: https://docs.aws.amazon.com/apigateway/latest/developerguide/request-response-data-mappings.html
        "integration.request.querystring.who": "method.request.querystring.who"
    },
    allow_test_invoke=True,
    request_templates={
        # You can define a mapping that will build a payload for your integration, based
        #  on the integration parameters that you have specified
        # Check: https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
        "application/json": JSON.stringify({"action": "sayHello", "poll_id": "$util.escapeJavaScript($input.params('who'))"})
    },
    # This parameter defines the behavior of the engine is no suitable response template is found
    passthrough_behavior=apigateway.PassthroughBehavior.NEVER,
    integration_responses=[apigateway.IntegrationResponse(
        # Successful response from the Lambda function, no filter defined
        #  - the selectionPattern filter only tests the error message
        # We will set the response status code to 200
        status_code="200",
        response_templates={
            # This template takes the "message" result from the Lambda function, and embeds it in a JSON response
            # Check https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
            "application/json": JSON.stringify({"state": "ok", "greeting": "$util.escapeJavaScript($input.body)"})
        },
        response_parameters={
            # We can map response parameters
            # - Destination parameters (the key) are the response parameters (used in mappings)
            # - Source parameters (the value) are the integration response parameters or expressions
            "method.response.header.Content-Type": "'application/json'",
            "method.response.header.Access-Control-Allow-Origin": "'*'",
            "method.response.header.Access-Control-Allow-Credentials": "'true'"
        }
    ), apigateway.IntegrationResponse(
        # For errors, we check if the error message is not empty, get the error data
        selection_pattern="(\n|.)+",
        # We will set the response status code to 200
        status_code="400",
        response_templates={
            "application/json": JSON.stringify({"state": "error", "message": "$util.escapeJavaScript($input.path('$.errorMessage'))"})
        },
        response_parameters={
            "method.response.header.Content-Type": "'application/json'",
            "method.response.header.Access-Control-Allow-Origin": "'*'",
            "method.response.header.Access-Control-Allow-Credentials": "'true'"
        }
    )
    ]
)
java
Function hello;


LambdaIntegration integration = LambdaIntegration.Builder.create(hello)
        .proxy(false)
        .requestParameters(Map.of(
                // You can define mapping parameters from your method to your integration
                // - Destination parameters (the key) are the integration parameters (used in mappings)
                // - Source parameters (the value) are the source request parameters or expressions
                // @see: https://docs.aws.amazon.com/apigateway/latest/developerguide/request-response-data-mappings.html
                "integration.request.querystring.who", "method.request.querystring.who"))
        .allowTestInvoke(true)
        .requestTemplates(Map.of(
                // You can define a mapping that will build a payload for your integration, based
                //  on the integration parameters that you have specified
                // Check: https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
                "application/json", JSON.stringify(Map.of("action", "sayHello", "pollId", "$util.escapeJavaScript($input.params('who'))"))))
        // This parameter defines the behavior of the engine is no suitable response template is found
        .passthroughBehavior(PassthroughBehavior.NEVER)
        .integrationResponses(List.of(IntegrationResponse.builder()
                // Successful response from the Lambda function, no filter defined
                //  - the selectionPattern filter only tests the error message
                // We will set the response status code to 200
                .statusCode("200")
                .responseTemplates(Map.of(
                        // This template takes the "message" result from the Lambda function, and embeds it in a JSON response
                        // Check https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
                        "application/json", JSON.stringify(Map.of("state", "ok", "greeting", "$util.escapeJavaScript($input.body)"))))
                .responseParameters(Map.of(
                        // We can map response parameters
                        // - Destination parameters (the key) are the response parameters (used in mappings)
                        // - Source parameters (the value) are the integration response parameters or expressions
                        "method.response.header.Content-Type", "'application/json'",
                        "method.response.header.Access-Control-Allow-Origin", "'*'",
                        "method.response.header.Access-Control-Allow-Credentials", "'true'"))
                .build(), IntegrationResponse.builder()
                // For errors, we check if the error message is not empty, get the error data
                .selectionPattern("(\n|.)+")
                // We will set the response status code to 200
                .statusCode("400")
                .responseTemplates(Map.of(
                        "application/json", JSON.stringify(Map.of("state", "error", "message", "$util.escapeJavaScript($input.path('$.errorMessage'))"))))
                .responseParameters(Map.of(
                        "method.response.header.Content-Type", "'application/json'",
                        "method.response.header.Access-Control-Allow-Origin", "'*'",
                        "method.response.header.Access-Control-Allow-Credentials", "'true'"))
                .build()))
        .build();
csharp
Function hello;


var integration = new LambdaIntegration(hello, new LambdaIntegrationOptions {
    Proxy = false,
    RequestParameters = new Dictionary<string, string> {
        // You can define mapping parameters from your method to your integration
        // - Destination parameters (the key) are the integration parameters (used in mappings)
        // - Source parameters (the value) are the source request parameters or expressions
        // @see: https://docs.aws.amazon.com/apigateway/latest/developerguide/request-response-data-mappings.html
        { "integration.request.querystring.who", "method.request.querystring.who" }
    },
    AllowTestInvoke = true,
    RequestTemplates = new Dictionary<string, string> {
        // You can define a mapping that will build a payload for your integration, based
        //  on the integration parameters that you have specified
        // Check: https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
        { "application/json", JSON.Stringify(new Dictionary<string, string> { { "action", "sayHello" }, { "pollId", "$util.escapeJavaScript($input.params('who'))" } }) }
    },
    // This parameter defines the behavior of the engine is no suitable response template is found
    PassthroughBehavior = PassthroughBehavior.NEVER,
    IntegrationResponses = new [] { new IntegrationResponse {
        // Successful response from the Lambda function, no filter defined
        //  - the selectionPattern filter only tests the error message
        // We will set the response status code to 200
        StatusCode = "200",
        ResponseTemplates = new Dictionary<string, string> {
            // This template takes the "message" result from the Lambda function, and embeds it in a JSON response
            // Check https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
            { "application/json", JSON.Stringify(new Dictionary<string, string> { { "state", "ok" }, { "greeting", "$util.escapeJavaScript($input.body)" } }) }
        },
        ResponseParameters = new Dictionary<string, string> {
            // We can map response parameters
            // - Destination parameters (the key) are the response parameters (used in mappings)
            // - Source parameters (the value) are the integration response parameters or expressions
            { "method.response.header.Content-Type", "'application/json'" },
            { "method.response.header.Access-Control-Allow-Origin", "'*'" },
            { "method.response.header.Access-Control-Allow-Credentials", "'true'" }
        }
    }, new IntegrationResponse {
        // For errors, we check if the error message is not empty, get the error data
        SelectionPattern = @"(
        |.)+",
        // We will set the response status code to 200
        StatusCode = "400",
        ResponseTemplates = new Dictionary<string, string> {
            { "application/json", JSON.Stringify(new Dictionary<string, string> { { "state", "error" }, { "message", "$util.escapeJavaScript($input.path('$.errorMessage'))" } }) }
        },
        ResponseParameters = new Dictionary<string, string> {
            { "method.response.header.Content-Type", "'application/json'" },
            { "method.response.header.Access-Control-Allow-Origin", "'*'" },
            { "method.response.header.Access-Control-Allow-Credentials", "'true'" }
        }
    } }
});
go
var hello Function


integration := apigateway.NewLambdaIntegration(hello, &LambdaIntegrationOptions{
	Proxy: jsii.Boolean(false),
	RequestParameters: map[string]*string{
		// You can define mapping parameters from your method to your integration
		// - Destination parameters (the key) are the integration parameters (used in mappings)
		// - Source parameters (the value) are the source request parameters or expressions
		// @see: https://docs.aws.amazon.com/apigateway/latest/developerguide/request-response-data-mappings.html
		"integration.request.querystring.who": jsii.String("method.request.querystring.who"),
	},
	AllowTestInvoke: jsii.Boolean(true),
	RequestTemplates: map[string]*string{
		// You can define a mapping that will build a payload for your integration, based
		//  on the integration parameters that you have specified
		// Check: https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
		"application/json": JSON.stringify(map[string]*string{
			"action": jsii.String("sayHello"),
			"pollId": jsii.String("$util.escapeJavaScript($input.params('who'))"),
		}),
	},
	// This parameter defines the behavior of the engine is no suitable response template is found
	PassthroughBehavior: apigateway.PassthroughBehavior_NEVER,
	IntegrationResponses: []IntegrationResponse{
		&IntegrationResponse{
			// Successful response from the Lambda function, no filter defined
			//  - the selectionPattern filter only tests the error message
			// We will set the response status code to 200
			StatusCode: jsii.String("200"),
			ResponseTemplates: map[string]*string{
				// This template takes the "message" result from the Lambda function, and embeds it in a JSON response
				// Check https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-mapping-template-reference.html
				"application/json": JSON.stringify(map[string]*string{
					"state": jsii.String("ok"),
					"greeting": jsii.String("$util.escapeJavaScript($input.body)"),
				}),
			},
			ResponseParameters: map[string]*string{
				// We can map response parameters
				// - Destination parameters (the key) are the response parameters (used in mappings)
				// - Source parameters (the value) are the integration response parameters or expressions
				"method.response.header.Content-Type": jsii.String("'application/json'"),
				"method.response.header.Access-Control-Allow-Origin": jsii.String("'*'"),
				"method.response.header.Access-Control-Allow-Credentials": jsii.String("'true'"),
			},
		},
		&IntegrationResponse{
			// For errors, we check if the error message is not empty, get the error data
			SelectionPattern: jsii.String("(\n|.)+"),
			// We will set the response status code to 200
			StatusCode: jsii.String("400"),
			ResponseTemplates: map[string]*string{
				"application/json": JSON.stringify(map[string]*string{
					"state": jsii.String("error"),
					"message": jsii.String("$util.escapeJavaScript($input.path('$.errorMessage'))"),
				}),
			},
			ResponseParameters: map[string]*string{
				"method.response.header.Content-Type": jsii.String("'application/json'"),
				"method.response.header.Access-Control-Allow-Origin": jsii.String("'*'"),
				"method.response.header.Access-Control-Allow-Credentials": jsii.String("'true'"),
			},
		},
	},
})

You can define models for your responses (and requests)

ts
declare const api: apigateway.RestApi;

// We define the JSON Schema for the transformed valid response
const responseModel = api.addModel('ResponseModel', {
  contentType: 'application/json',
  modelName: 'ResponseModel',
  schema: {
    schema: apigateway.JsonSchemaVersion.DRAFT4,
    title: 'pollResponse',
    type: apigateway.JsonSchemaType.OBJECT,
    properties: {
      state: { type: apigateway.JsonSchemaType.STRING },
      greeting: { type: apigateway.JsonSchemaType.STRING }
    }
  }
});

// We define the JSON Schema for the transformed error response
const errorResponseModel = api.addModel('ErrorResponseModel', {
  contentType: 'application/json',
  modelName: 'ErrorResponseModel',
  schema: {
    schema: apigateway.JsonSchemaVersion.DRAFT4,
    title: 'errorResponse',
    type: apigateway.JsonSchemaType.OBJECT,
    properties: {
      state: { type: apigateway.JsonSchemaType.STRING },
      message: { type: apigateway.JsonSchemaType.STRING }
    }
  }
});
python
# api: apigateway.RestApi


# We define the JSON Schema for the transformed valid response
response_model = api.add_model("ResponseModel",
    content_type="application/json",
    model_name="ResponseModel",
    schema=apigateway.JsonSchema(
        schema=apigateway.JsonSchemaVersion.DRAFT4,
        title="pollResponse",
        type=apigateway.JsonSchemaType.OBJECT,
        properties={
            "state": apigateway.JsonSchema(type=apigateway.JsonSchemaType.STRING),
            "greeting": apigateway.JsonSchema(type=apigateway.JsonSchemaType.STRING)
        }
    )
)

# We define the JSON Schema for the transformed error response
error_response_model = api.add_model("ErrorResponseModel",
    content_type="application/json",
    model_name="ErrorResponseModel",
    schema=apigateway.JsonSchema(
        schema=apigateway.JsonSchemaVersion.DRAFT4,
        title="errorResponse",
        type=apigateway.JsonSchemaType.OBJECT,
        properties={
            "state": apigateway.JsonSchema(type=apigateway.JsonSchemaType.STRING),
            "message": apigateway.JsonSchema(type=apigateway.JsonSchemaType.STRING)
        }
    )
)
java
RestApi api;


// We define the JSON Schema for the transformed valid response
Model responseModel = api.addModel("ResponseModel", ModelOptions.builder()
        .contentType("application/json")
        .modelName("ResponseModel")
        .schema(JsonSchema.builder()
                .schema(JsonSchemaVersion.DRAFT4)
                .title("pollResponse")
                .type(JsonSchemaType.OBJECT)
                .properties(Map.of(
                        "state", JsonSchema.builder().type(JsonSchemaType.STRING).build(),
                        "greeting", JsonSchema.builder().type(JsonSchemaType.STRING).build()))
                .build())
        .build());

// We define the JSON Schema for the transformed error response
Model errorResponseModel = api.addModel("ErrorResponseModel", ModelOptions.builder()
        .contentType("application/json")
        .modelName("ErrorResponseModel")
        .schema(JsonSchema.builder()
                .schema(JsonSchemaVersion.DRAFT4)
                .title("errorResponse")
                .type(JsonSchemaType.OBJECT)
                .properties(Map.of(
                        "state", JsonSchema.builder().type(JsonSchemaType.STRING).build(),
                        "message", JsonSchema.builder().type(JsonSchemaType.STRING).build()))
                .build())
        .build());
csharp
RestApi api;


// We define the JSON Schema for the transformed valid response
var responseModel = api.AddModel("ResponseModel", new ModelOptions {
    ContentType = "application/json",
    ModelName = "ResponseModel",
    Schema = new JsonSchema {
        Schema = JsonSchemaVersion.DRAFT4,
        Title = "pollResponse",
        Type = JsonSchemaType.OBJECT,
        Properties = new Dictionary<string, JsonSchema> {
            { "state", new JsonSchema { Type = JsonSchemaType.STRING } },
            { "greeting", new JsonSchema { Type = JsonSchemaType.STRING } }
        }
    }
});

// We define the JSON Schema for the transformed error response
var errorResponseModel = api.AddModel("ErrorResponseModel", new ModelOptions {
    ContentType = "application/json",
    ModelName = "ErrorResponseModel",
    Schema = new JsonSchema {
        Schema = JsonSchemaVersion.DRAFT4,
        Title = "errorResponse",
        Type = JsonSchemaType.OBJECT,
        Properties = new Dictionary<string, JsonSchema> {
            { "state", new JsonSchema { Type = JsonSchemaType.STRING } },
            { "message", new JsonSchema { Type = JsonSchemaType.STRING } }
        }
    }
});
go
var api RestApi


// We define the JSON Schema for the transformed valid response
responseModel := api.AddModel(jsii.String("ResponseModel"), &ModelOptions{
	ContentType: jsii.String("application/json"),
	ModelName: jsii.String("ResponseModel"),
	Schema: &JsonSchema{
		Schema: apigateway.JsonSchemaVersion_DRAFT4,
		Title: jsii.String("pollResponse"),
		Type: apigateway.JsonSchemaType_OBJECT,
		Properties: map[string]JsonSchema{
			"state": &JsonSchema{
				"type": apigateway.JsonSchemaType_STRING,
			},
			"greeting": &JsonSchema{
				"type": apigateway.JsonSchemaType_STRING,
			},
		},
	},
})

// We define the JSON Schema for the transformed error response
errorResponseModel := api.AddModel(jsii.String("ErrorResponseModel"), &ModelOptions{
	ContentType: jsii.String("application/json"),
	ModelName: jsii.String("ErrorResponseModel"),
	Schema: &JsonSchema{
		Schema: apigateway.JsonSchemaVersion_DRAFT4,
		Title: jsii.String("errorResponse"),
		Type: apigateway.JsonSchemaType_OBJECT,
		Properties: map[string]JsonSchema{
			"state": &JsonSchema{
				"type": apigateway.JsonSchemaType_STRING,
			},
			"message": &JsonSchema{
				"type": apigateway.JsonSchemaType_STRING,
			},
		},
	},
})

And reference all on your method definition.

ts
declare const integration: apigateway.LambdaIntegration;
declare const resource: apigateway.Resource;
declare const responseModel: apigateway.Model;
declare const errorResponseModel: apigateway.Model;

resource.addMethod('GET', integration, {
  // We can mark the parameters as required
  requestParameters: {
    'method.request.querystring.who': true
  },
  // we can set request validator options like below
  requestValidatorOptions: {
    requestValidatorName: 'test-validator',
    validateRequestBody: true,
    validateRequestParameters: false
  },
  methodResponses: [
    {
      // Successful response from the integration
      statusCode: '200',
      // Define what parameters are allowed or not
      responseParameters: {
        'method.response.header.Content-Type': true,
        'method.response.header.Access-Control-Allow-Origin': true,
        'method.response.header.Access-Control-Allow-Credentials': true
      },
      // Validate the schema on the response
      responseModels: {
        'application/json': responseModel
      }
    },
    {
      // Same thing for the error responses
      statusCode: '400',
      responseParameters: {
        'method.response.header.Content-Type': true,
        'method.response.header.Access-Control-Allow-Origin': true,
        'method.response.header.Access-Control-Allow-Credentials': true
      },
      responseModels: {
        'application/json': errorResponseModel
      }
    }
  ]
});
python
# integration: apigateway.LambdaIntegration
# resource: apigateway.Resource
# response_model: apigateway.Model
# error_response_model: apigateway.Model


resource.add_method("GET", integration,
    # We can mark the parameters as required
    request_parameters={
        "method.request.querystring.who": True
    },
    # we can set request validator options like below
    request_validator_options=apigateway.RequestValidatorOptions(
        request_validator_name="test-validator",
        validate_request_body=True,
        validate_request_parameters=False
    ),
    method_responses=[apigateway.MethodResponse(
        # Successful response from the integration
        status_code="200",
        # Define what parameters are allowed or not
        response_parameters={
            "method.response.header.Content-Type": True,
            "method.response.header.Access-Control-Allow-Origin": True,
            "method.response.header.Access-Control-Allow-Credentials": True
        },
        # Validate the schema on the response
        response_models={
            "application/json": response_model
        }
    ), apigateway.MethodResponse(
        # Same thing for the error responses
        status_code="400",
        response_parameters={
            "method.response.header.Content-Type": True,
            "method.response.header.Access-Control-Allow-Origin": True,
            "method.response.header.Access-Control-Allow-Credentials": True
        },
        response_models={
            "application/json": error_response_model
        }
    )
    ]
)
java
LambdaIntegration integration;
Resource resource;
Model responseModel;
Model errorResponseModel;


resource.addMethod("GET", integration, MethodOptions.builder()
        // We can mark the parameters as required
        .requestParameters(Map.of(
                "method.request.querystring.who", true))
        // we can set request validator options like below
        .requestValidatorOptions(RequestValidatorOptions.builder()
                .requestValidatorName("test-validator")
                .validateRequestBody(true)
                .validateRequestParameters(false)
                .build())
        .methodResponses(List.of(MethodResponse.builder()
                // Successful response from the integration
                .statusCode("200")
                // Define what parameters are allowed or not
                .responseParameters(Map.of(
                        "method.response.header.Content-Type", true,
                        "method.response.header.Access-Control-Allow-Origin", true,
                        "method.response.header.Access-Control-Allow-Credentials", true))
                // Validate the schema on the response
                .responseModels(Map.of(
                        "application/json", responseModel))
                .build(), MethodResponse.builder()
                // Same thing for the error responses
                .statusCode("400")
                .responseParameters(Map.of(
                        "method.response.header.Content-Type", true,
                        "method.response.header.Access-Control-Allow-Origin", true,
                        "method.response.header.Access-Control-Allow-Credentials", true))
                .responseModels(Map.of(
                        "application/json", errorResponseModel))
                .build()))
        .build());
csharp
LambdaIntegration integration;
Resource resource;
Model responseModel;
Model errorResponseModel;


resource.AddMethod("GET", integration, new MethodOptions {
    // We can mark the parameters as required
    RequestParameters = new Dictionary<string, boolean> {
        { "method.request.querystring.who", true }
    },
    // we can set request validator options like below
    RequestValidatorOptions = new RequestValidatorOptions {
        RequestValidatorName = "test-validator",
        ValidateRequestBody = true,
        ValidateRequestParameters = false
    },
    MethodResponses = new [] { new MethodResponse {
        // Successful response from the integration
        StatusCode = "200",
        // Define what parameters are allowed or not
        ResponseParameters = new Dictionary<string, boolean> {
            { "method.response.header.Content-Type", true },
            { "method.response.header.Access-Control-Allow-Origin", true },
            { "method.response.header.Access-Control-Allow-Credentials", true }
        },
        // Validate the schema on the response
        ResponseModels = new Dictionary<string, IModel> {
            { "application/json", responseModel }
        }
    }, new MethodResponse {
        // Same thing for the error responses
        StatusCode = "400",
        ResponseParameters = new Dictionary<string, boolean> {
            { "method.response.header.Content-Type", true },
            { "method.response.header.Access-Control-Allow-Origin", true },
            { "method.response.header.Access-Control-Allow-Credentials", true }
        },
        ResponseModels = new Dictionary<string, IModel> {
            { "application/json", errorResponseModel }
        }
    } }
});
go
var integration LambdaIntegration
var resource Resource
var responseModel Model
var errorResponseModel Model


resource.AddMethod(jsii.String("GET"), integration, &MethodOptions{
	// We can mark the parameters as required
	RequestParameters: map[string]*bool{
		"method.request.querystring.who": jsii.Boolean(true),
	},
	// we can set request validator options like below
	RequestValidatorOptions: &RequestValidatorOptions{
		RequestValidatorName: jsii.String("test-validator"),
		ValidateRequestBody: jsii.Boolean(true),
		ValidateRequestParameters: jsii.Boolean(false),
	},
	MethodResponses: []MethodResponse{
		&MethodResponse{
			// Successful response from the integration
			StatusCode: jsii.String("200"),
			// Define what parameters are allowed or not
			ResponseParameters: map[string]*bool{
				"method.response.header.Content-Type": jsii.Boolean(true),
				"method.response.header.Access-Control-Allow-Origin": jsii.Boolean(true),
				"method.response.header.Access-Control-Allow-Credentials": jsii.Boolean(true),
			},
			// Validate the schema on the response
			ResponseModels: map[string]IModel{
				"application/json": responseModel,
			},
		},
		&MethodResponse{
			// Same thing for the error responses
			StatusCode: jsii.String("400"),
			ResponseParameters: map[string]*bool{
				"method.response.header.Content-Type": jsii.Boolean(true),
				"method.response.header.Access-Control-Allow-Origin": jsii.Boolean(true),
				"method.response.header.Access-Control-Allow-Credentials": jsii.Boolean(true),
			},
			ResponseModels: map[string]IModel{
				"application/json": errorResponseModel,
			},
		},
	},
})

Specifying requestValidatorOptions automatically creates the RequestValidator construct with the given options. However, if you have your RequestValidator already initialized or imported, use the requestValidator option instead.

If you want to use requestValidatorOptions in multiple addMethod() calls then you need to set the @aws-cdk/aws-apigateway:requestValidatorUniqueId feature flag. When this feature flag is set, each RequestValidator will have a unique generated id.

Note if you enable this feature flag when you have already used addMethod() with requestValidatorOptions the Logical Id of the resource will change causing the resource to be replaced.

ts
declare const integration: apigateway.LambdaIntegration;
declare const resource: apigateway.Resource;
declare const responseModel: apigateway.Model;
declare const errorResponseModel: apigateway.Model;

resource.node.setContext('@aws-cdk/aws-apigateway:requestValidatorUniqueId', true);

resource.addMethod('GET', integration, {
  // we can set request validator options like below
  requestValidatorOptions: {
    requestValidatorName: 'test-validator',
    validateRequestBody: true,
    validateRequestParameters: false
  },
});

resource.addMethod('POST', integration, {
  // we can set request validator options like below
  requestValidatorOptions: {
    requestValidatorName: 'test-validator2',
    validateRequestBody: true,
    validateRequestParameters: false
  },
});
python
# integration: apigateway.LambdaIntegration
# resource: apigateway.Resource
# response_model: apigateway.Model
# error_response_model: apigateway.Model


resource.node.set_context("@aws-cdk/aws-apigateway:requestValidatorUniqueId", True)

resource.add_method("GET", integration,
    # we can set request validator options like below
    request_validator_options=apigateway.RequestValidatorOptions(
        request_validator_name="test-validator",
        validate_request_body=True,
        validate_request_parameters=False
    )
)

resource.add_method("POST", integration,
    # we can set request validator options like below
    request_validator_options=apigateway.RequestValidatorOptions(
        request_validator_name="test-validator2",
        validate_request_body=True,
        validate_request_parameters=False
    )
)
java
LambdaIntegration integration;
Resource resource;
Model responseModel;
Model errorResponseModel;


resource.node.setContext("@aws-cdk/aws-apigateway:requestValidatorUniqueId", true);

resource.addMethod("GET", integration, MethodOptions.builder()
        // we can set request validator options like below
        .requestValidatorOptions(RequestValidatorOptions.builder()
                .requestValidatorName("test-validator")
                .validateRequestBody(true)
                .validateRequestParameters(false)
                .build())
        .build());

resource.addMethod("POST", integration, MethodOptions.builder()
        // we can set request validator options like below
        .requestValidatorOptions(RequestValidatorOptions.builder()
                .requestValidatorName("test-validator2")
                .validateRequestBody(true)
                .validateRequestParameters(false)
                .build())
        .build());
csharp
LambdaIntegration integration;
Resource resource;
Model responseModel;
Model errorResponseModel;


resource.Node.SetContext("@aws-cdk/aws-apigateway:requestValidatorUniqueId", true);

resource.AddMethod("GET", integration, new MethodOptions {
    // we can set request validator options like below
    RequestValidatorOptions = new RequestValidatorOptions {
        RequestValidatorName = "test-validator",
        ValidateRequestBody = true,
        ValidateRequestParameters = false
    }
});

resource.AddMethod("POST", integration, new MethodOptions {
    // we can set request validator options like below
    RequestValidatorOptions = new RequestValidatorOptions {
        RequestValidatorName = "test-validator2",
        ValidateRequestBody = true,
[...]
